DECLARE SUB Flags ()
'
'
'
'
'          ĳ     Ŀ  ĳ Ŀ  Ŀ        Ŀ      
'         Ŀ  Ŀ   ĳ               /       Ŀ
'                         
'             (C) Copyright 1992, 1993 by Brandon Bannerman.
'
'  This is the long-awaited source code to ShipEdit, my oldest and one of my
'most popular programs. Before you dive right in and start greedily typing
'away, take a moment to read the following:
'  I, Brandon Bannerman, hereby place ShipEdit and its accompanying source
'codes into the public domain. This means that you may modify, recompile, and
'abuse these source codes to your heart's content, so long as you do not
'distribute modified copies of it under the pretense that they are original
'copies of ShipEdit. You may modify the code and redistribute the modified
'copy, so long as at least half of the coding is your own work, bearing your
'own name with credit given where credit is due. (For anything less than a
'complete rewrite, you might as well have told me what you wanted to see and
'let me do the work) I also hereby grant permission to excerpt portions of
'this code and the accompanying libraries and incorporate them into your own
'programs, so long as credit is given somewhere in the documentation or
'the program itself. I explicitly forbid you to distribute modified copies
'of this code, compiled or uncompiled, that bear my name or the name
'"ShipEdit" (ie: hacks), with the sole exception of the file header in
'ShipKit files, which must say "TW2002 ShipEdit Kit File" in order to be
'compatible with ShipEdit and KitWorks.
'  In plain English, I don't mind you copying, using, or otherwise having
'jolly good fun with the coding, so long as you're not trying to give me
'a bad name, rip me off, or give the program a bad name by distributing
'hacked copies of ShipEdit under the pretense that I wrote them. Consider
'this code to be for your own personal edification, and you can't go wrong.
'  Comments, suggestions, patches of your own design, donations, or
'any other support or contribution to the ongoing development of ShipEdit are
'welcome. You can reach me by surface mail at:
'  Brandon Bannerman
'  27908 84th Ave So
'  Kent, WA 98032-8625
'In addition, I (and my programs) can be found on The DarkStar StarDock at:
'  (206) 431-1243 (2400)
'  (206) 431-0291 (14400)
'
'  Anyway...
'
DEFINT A-Z
  'Define all variables starting with the letters A to Z as integers unless
  'otherwise predefined.
DECLARE SUB TheEnd ()
  'Prints out the termination message.
DECLARE FUNCTION CLon$ (LongVal&)
  '
DECLARE SUB Help ()
  'Not really used yet. I was planning to put a Help screen into ShipEdit,
  'and actually had the key in the main menu in v2.4, but I *still* haven't
  'thought of anything that isn't pretty straightforward and self-explanatory.
DECLARE SUB Summary ()
  'The ShipEdit/KitWorks summary screen.
DECLARE FUNCTION KitNum% ()
  'Calculates the BINARY offset of ShipNum in a ShipKit. I was lazy that day.
DECLARE SUB InstKit ()
  'Installs a ShipKit in TW2002. This is very different than the routine in
  'KitWorks, should you also have the source to that.
DECLARE SUB PutData ()
  'Puts the data for all the ShipTypes in memory into TW2002. Again, this bears
  'little resemblance to the routine in KitWorks by the same name.
DECLARE SUB GetData ()
  'Ditto.
DECLARE SUB MakeKit (FiNa$)
  'Ditto thrice.
DECLARE SUB ParseCLine ()
  'Parses the command-line parameters. This is almost a carbon-copy of the
  'routine by the same name in KitWorks, with the exception that ShipEdit
  'has a handful more parameters to take care of.
DECLARE SUB GetInput (MinVal&, MaxVal&)
  'A routine using GetLin (see SHIPLIB.BAS) to get a integer value, depending
  'on a definable minimum and maximum value.
DECLARE SUB CLSWindow ()
  'Clears the dialogue window. In this version, I chose to clear it before
  'a commmand is done, rather than after--because, like Tedit, ShipEdit had
  'an annoying habit of CLSing data the user wanted to see.
DECLARE FUNCTION SFill$ (StringVar$, MaxLen%)
  'SFill$ is a number of spaces equal to the MaxLen% minus the length of
  'StringVar$. Used for erasing extraneous output on the same screen, such
  'as if you'd just printed "1000", then wanted to print 12, you would:
  'PRINT "12"; SFill$("12", 4)
DECLARE FUNCTION CVal$ (IntVal%)
  'Abbreviation for C++ Val of IntVal%, this is a bitter tongue-in-cheek
  'reference to the fact that QB has an annoying habit of printing a space
  'before a positive integer (supposedly, where the + sign would go), even
  'though it doesn't use this except in a PRINT USING statement. C++, on the
  'other hand, does not. (At least, not that I'm aware of) Anyway, this
  'removes all leading and trailing spaces from an integer variable.
DECLARE SUB ParseShipFac ()
  'Parses the Ship Factors of the current ship.
'
'$INCLUDE: 'ShipLib.BI'
'
ON ERROR GOTO Erred
  'Pretty confusing line label, wot?
CLS
Pstra ("~EShipEdit Release Version ~D2.6~!~A")
PRINT "  Dimensioning Variables";
  'I put this running commentary on what the program was doing in as a matter
  'of diagnosing any bugs that might pop up while I was designing this
  'program. I forgot to take them out, but found out later that people
  'actually liked knowing what the program was doing, so I kept them in.
'
'I haven't quite gotten around to cleaning up the code from earlier versions
'of ShipEdit. There still may be (and probably are) quite a few variables
'that aren't used any more, out of date or messy code, etc.
'
DIM SHARED FileHeader AS STRING * 25
DIM SHARED Kit AS INTEGER
DIM SHARED Filename AS STRING * 8
DIM SHARED Parm$(1 TO 4)
DIM SHARED NewVal AS STRING
DIM SHARED EC AS INTEGER
DIM SHARED ShipPrice AS LONG
DIM SHARED Odds AS SINGLE
DIM SHARED mR AS INTEGER
DIM SHARED ShipNum AS INTEGER
DIM SHARED ColString AS STRING * 2
DIM SHARED Align AS INTEGER
DIM SHARED ShipAbb AS STRING * 6
DIM SHARED MMFac AS LONG
DIM SHARED OffFac AS LONG
DIM SHARED DefFac AS LONG
DIM SHARED ShipFac AS LONG
DIM SHARED NewPath AS STRING
DIM SHARED RawString AS STRING * 23
DIM SHARED V103D AS INTEGER
DIM SHARED Offset AS INTEGER
DIM SHARED Backup AS INTEGER
DIM SHARED SF.C AS INTEGER
DIM SHARED SF.D AS INTEGER
DIM SHARED SF.E AS INTEGER
DIM SHARED SF.F AS INTEGER
DIM SHARED SF.J AS INTEGER
DIM SHARED SF.K AS INTEGER
DIM SHARED SF.R AS INTEGER
DIM SHARED SF.S1 AS INTEGER
DIM SHARED SF.S2 AS INTEGER
'
V103D = False
'A boolean variable which tells the program whether to use v1.03 or v1.03D
'offsets for the executable files. It defaults to v1.03, but automatically
'detects v1.03D.
'
Kit = False
'Tells ShipEdit whether or not to Install a kit from the commandline.
'
'It isn't actually necessary to set all these, since False is equal to 0,
'the value all variables start with. I just do it for GP.
'
PRINT
PRINT "  Parsing Commandline"
ParseCLine
  'A quirk of QuickBasic that should be noted: routines like Pstra and
  'ParseCLine, which have either one or no parameters, can be called
  'directly--ie, without the CALL statement--while those with two or more
  'parameters, such as Selection, must use CALL. Weird.
IF NewPath = "" THEN NP$ = "current directory" ELSE NP$ = LTRIM$(LEFT$(NewPath, LEN(NewPath) - 1))
PRINT "   - Getting all files from "; RTRIM$(NP$)


PRINT "  Opening Files"
File$ = NewPath + "ShipStat.Dat"
OPEN File$ FOR RANDOM AS #1 LEN = 45
File$ = NewPath + "tw2002.exe"
OPEN File$ FOR BINARY AS #2
File$ = NewPath + "tedit.exe"
OPEN File$ FOR BINARY AS #3
File$ = NewPath + "tw2002.ovr"
OPEN File$ FOR BINARY AS #4
File$ = NewPath + "shipedit.ovr"
OPEN File$ FOR BINARY AS #6

PRINT "  Checking Files"
IF LOF(2) = 87504 THEN
  V103D = True
ELSEIF LOF(2) = 86736 THEN
  V103D = False
ELSEIF LOF(2) = 0 THEN
  PRINT "  TW2002 Not Found"
  IF LOF(1) = 0 THEN
    CLOSE #1
    KILL (NewPath + "ShipStat.Dat")
  END IF
  IF LOF(2) = 0 THEN
    CLOSE #2
    KILL (NewPath + "TW2002.Exe")
  END IF
  IF LOF(3) = 0 THEN
    CLOSE #3
    KILL (NewPath + "Tedit.Exe")
  END IF
  IF LOF(4) = 0 THEN
    CLOSE #4
    KILL (NewPath + "TW2002.Ovr")
  END IF
  ERROR 201
  'It kills all these files, assuming that since TW2002.EXE didn't exist
  '(ie, it had a length of 0--BINARY mode opens nonexistant files as new),
  'that none of the other TW2002 files will. Perhaps sloppy, but it's better
  'than leaving a bunch of length 0 files around.
ELSE
  PRINT "  TW2002.EXE Invalid Size"
  ERROR 202
  'If TW2002.EXE is any size other than 0, or the sizes for 1.03 and 1.03D,
  'then ShipEdit assumes that it is dealing with a different version of TW2002
  'than it is meant to, and exits (while leaving TW2002.EXE intact).
END IF

IF LOF(6) = 0 THEN
  CLOSE
  KILL NewPath + "SHIPEDIT.OVR"
  PRINT "  SHIPEDIT.OVR Not Found"
  ERROR 203
ELSEIF LOF(6) <> 4367 THEN
  PRINT "  SHIPEDIT.OVR Invalid Size"
  ERROR 204
END IF

IF V103D THEN
  PRINT "  TW2002 Version 1.03D of Detected"
ELSE
  PRINT "  TW2002 Version 1.03 Standard Detected"
END IF
  'Tell the users what I'm doing to their precious game...

IF Backup THEN
  PRINT "   - Backing up shiptypes to {BACKUP}.KIT"
  MakeKit ("{BACKUP}")
  'If the /BU parameter is detected, back up the shiptypes to {BACKUP}.KIT.
END IF

IF Kit THEN
  PRINT
  COLOR 12
  PRINT "Installing ShipEdit Kit "; : COLOR 4: PRINT ": "; : COLOR 14: PRINT Filename$; : COLOR 12: PRINT "...";
  CALL InstKit
  COLOR 14: PRINT "Done."
  GOTO Ender
  'It the /K:KitFile parameter is detected, install KitFile.KIT.
END IF

BLOAD "SHIPEDIT.OVR"
  'Print out the Main Menu.

DO
  CALL GetData
  Ship$ = RawString
  Ship$ = TWTtoBST(Ship$)
  ColString = LEFT$(Ship$, 2)
  Ship$ = MID$(Ship$, 3, LEN(Ship$) - 4)
    'Split the raw ship string into the first color string, the name itself,
    'and the terminating ~5 which resets the color to green.
  CALL ParseShipFac
    'Parse the ship factor.
  LOCATE 2, 40
  Pstra (ColString + Ship$): COLOR 3, 0: PRINT " #"; : COLOR 11: PRINT CVal$(ShipNum); : COLOR 9: PRINT " ]" + SFill$(Ship$, 22);
    'Print out the ship name, number, and respective menu items.
  COLOR 14
  LOCATE 4, 27: PRINT USING "#####"; ShipType.HoldCost;
  LOCATE 5, 27: PRINT USING "#####"; ShipType.DrivCost;
  LOCATE 6, 27: PRINT USING "#####"; ShipType.CompCost;
  LOCATE 7, 27: PRINT USING "#####"; ShipType.HullCost;
  LOCATE 8, 20: PRINT USING "######"; ShipPrice;
  LOCATE 9, 27: PRINT USING "#####"; ShipType.InitHolds;
  LOCATE 10, 27: PRINT USING "#####"; ShipType.MaxHolds;
  LOCATE 11, 27: PRINT USING "#####"; ShipType.MaxFtr;
  LOCATE 4, 57: PRINT USING "#####"; ShipType.MaxShi;
  LOCATE 5, 57: PRINT USING "#####"; ShipType.MaxFtrAtt;
  LOCATE 6, 57: PRINT USING "#####"; ShipType.MaxMines;
  LOCATE 7, 57: PRINT USING "#####"; ShipType.MaxBeac;
  LOCATE 8, 57: PRINT USING "#####"; ShipType.MaxGen;
  LOCATE 9, 57: PRINT USING "#####"; mR
    'Print most of the ship values right justified...
  LOCATE 10, 57: PRINT ShipAbb;
    '...the ship abbreviation...
  LOCATE 11, 57: PRINT USING "##.#"; Odds;
  Pstra ("~E:~D1")
    '...the offensive odds...
  LOCATE 7, 70: PRINT OffFac; SFill$(STR$(OffFac), 8);
  LOCATE 10, 70: PRINT DefFac; SFill$(STR$(DefFac), 8);
  LOCATE 13, 70: PRINT MMFac; SFill$(STR$(MMFac), 8);
  LOCATE 16, 70: PRINT ShipFac; SFill$(STR$(ShipFac), 8);
    '...the ship factors...
  LOCATE 14, 28
  IF ShipType.LRS = CHR$(1) THEN
    PRINT "Yes";
  ELSE
    PRINT "No ";
  END IF
  LOCATE 15, 28
  IF ShipType.TWD = CHR$(1) THEN
    PRINT "Yes"
  ELSE
    PRINT "No "
  END IF
  LOCATE 14, 55
  IF ShipType.PLS = CHR$(1) THEN
    PRINT "Yes"
  ELSE
    PRINT "No "
  END IF
    '...the flagged variables...
  LOCATE 15, 57
  PRINT USING "#####"; ShipType.MaxPHM
    '...and the photon missiles.
  LOCATE 16, 5
    COLOR 9
  IF ShipNum = SF.R THEN
    PRINT "<";
    COLOR 14
    PRINT "S";
    COLOR 9
    PRINT "]";
    COLOR 11
    PRINT " Alignment Needed to buy Ship #"; LTRIM$(STR$(SF.R));
    COLOR 7
    PRINT "  ";
    COLOR 14
    PRINT CVal$(Align);
    COLOR 9
    PRINT " or above     ";
  ELSE
    PRINT ""; STRING$(55, 32);
  END IF
    'If the ship number is SF.R, print out the alignment needed for it.
  Allowed$ = "ABCDEFGHIJKLMNOQZabcdefghijklmnoqz^*!+[]1234"
    'Set the filter for the GetKey function.
  IF ShipNum = SF.R THEN Allowed$ = Allowed$ + "Ss"
    'If the ship number is 9, add the menu selection for the alignment.
  TI$ = UCASE$(GetKey(Allowed$))
    'Get the key. (Duh)
  CLSWindow
    'Clear the dialogue window once the input is received.
  LOCATE 18, 3
  SELECT CASE UCASE$(TI$)
    CASE "Z"
      COLOR 10
      Pstra ("Current Ship Name ~c: ~D")
      PRINT Ship$
      LOCATE 19, 3
      Pstra ("~CEnter a new name for this ship, maximum 18 characters ~c: ")
      Ship$ = GetLin(18, "")
      IF LEN(Ship$) > 18 THEN Ship$ = LEFT$(Ship$, 18)
      Ship$ = RTRIM$(Ship$)
      LenSh = LEN(Ship$)
      IF LenSh > 0 THEN
        Ship$ = ColString + Ship$ + "~5"
        RawString = BSTtoTWT(Ship$, 23)
        IF V103D THEN
          PUT #2, 85399 + (ShipNum * 23), RawString
          PUT #3, 62119 + (ShipNum * 23), RawString
        ELSE
          PUT #2, 84654 + ((ShipNum - 1) * 23), RawString
          PUT #3, 60999 + ((ShipNum - 1) * 23), RawString
        END IF
        LOCATE 20, 3: Pstra ("~COkay.")
      ELSE
        LOCATE 20, 1: Pstra ("~B ~HNothing Done.")
      END IF
    CASE "N"
      COLOR 10
      PRINT "On the SysOp's side, TradeWars displays a six-letter abbreviation for the."
      LOCATE 19, 3
      PRINT "shiptype the current user is using. Enter a replacement for this abbreviation"
      LOCATE 20, 3
      Pstra ("six characters exactly ~c: ")
      Ship$ = GetLin(6, "")
      LOCATE 21, 3
      IF LEN(Ship$) = 6 THEN
        ShipAbb = Ship$
        Pstra ("~COkay.")
      ELSEIF Ship$ = "" THEN
        Pstra ("~HNothing Done.")
      ELSE
        Pstra ("~BAbbreviation must be 6 characters.")
      END IF
    CASE "!"
      COLOR 10
      PRINT "Select the color code that this ship will begin with. Examples are given"
      LOCATE 19, 3
      PRINT "below. Feel free to experiment! (Esc Aborts)"
      LOCATE 20, 3
      Pstra ("~aa ~bb ~cc ~dd ~ee ~ff ~gg ~hh ~AA ~BB ~CC ~DD ~EE ~FF ~GG ~HH ~11~H ~22~h ~33~h ~44~h ~55~h ~66~h")
      LOCATE 21, 3
      Pstra ("~ECurrent Color Code ~e: " + ColString + "~" + ColString + "~h~!")
      LOCATE 22, 3
      Pstra ("~ENew Color Code ~e: ~D")
      Col$ = GetKey(Alpha + Numeric + CHR$(27))
      IF Col$ <> CHR$(27) THEN
        ColString = "~" + Col$
        Pstra (Col$ + " = " + ColString + "This Color~h")
        Ship$ = ColString + Ship$ + "~5"
        RawString = BSTtoTWT(Ship$, 23)
        IF V103D THEN
          PUT #2, 85399 + (ShipNum * 23), RawString
          PUT #3, 62119 + (ShipNum * 23), RawString
        ELSE
          PUT #2, 84654 + ((ShipNum - 1) * 23), RawString
          PUT #3, 60999 + ((ShipNum - 1) * 23), RawString
        END IF
        LOCATE 23, 3: Pstra ("~COkay.")
      ELSE
        COLOR 15
        PRINT "Aborted. Nothing Done."
      END IF
      'Unlike most ship editors, ShipEdit splits the raw ship string received
      'from TW2002 into three parts--the primary color code, the ship name, and
      'the terminating color code. I chose not to allow editing of the
      'terminating color code--it is always assigned as the TW2002 default of
      '~5--because I saw no sensible reason to change it. If you do, it makes
      'the TW2002 output look like shit. Therefore, I don't factor it into the
      'editable ship string--even though the constant in TW2002 has a maximum
      'length of 22, (the raw string has a length of 23 because of the Pascal
      'prefix byte) you can only give a ship a name 18 characters long in
      'ShipEdit. I made the primary color code separate as well, for ease of
      'use by the user. In using other ship editors, I found it to be very
      'time-consuming to experiment with entering the entire name every time
      'you wanted to change the color or find out what a new color did. Note
      'that internal combinations are possible--you can give a ship a color
      'of, say, ~6 (blinking red) and then set off a different part of the
      'name by putting, for example, ~D (Bright Yellow) into the actual name
      'string. ShipEdit will parse the color change.
    CASE "A"
      COLOR 10
      PRINT "How much should the Holds Cost portion of the total cost be? (1-32767)"
      LOCATE 19, 2
      CALL GetInput(1, 32767)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.HoldCost = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
    CASE "B"
      COLOR 10
      PRINT "How much should the Drive Cost portion of the total cost be? (1-32767)"
      LOCATE 19, 2
      CALL GetInput(1, 32767)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.DrivCost = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
    CASE "C"
      COLOR 10
      PRINT "How much should the Computer Cost portion of the total cost be? (1-32767)"
      LOCATE 19, 2
      CALL GetInput(1, 32767)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.CompCost = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
    CASE "D"
      COLOR 10
      PRINT "How much should the Hull Cost portion of the total cost be? (1-32767)"
      LOCATE 19, 2
      CALL GetInput(1, 32767)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.HullCost = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'I didn't allow prices of 0 in ShipEdit on a hunch. I haven't tested
      'to see whether or not a 0 value would crash TW2002, but it's a safe
      'bet that it would since I think the sellback routines engage in
      'division.
    CASE "E"
      COLOR 10
      PRINT "How many holds should this ship start out with? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.InitHolds = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Be very careful with this value. TW2002 judges the buying hold cost
      'for the shiptype from the HoldCost value, however, it judges the
      'sellback value based on the number of holds on the ship. If you give
      'a ship too many init holds, the sellback value will be more than the
      'buying value, and you will have a ship that players can make millions
      'from simply by buying it and selling it back.

    CASE "F"
      COLOR 10
      PRINT "What should the maximum holds for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxHolds = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Point of common sense--you really shouldn't set the maximum holds as
      'something lower than the init holds. Setting them as equal would be
      'interesting, however--a ship that couldn't be expanded in that area?
      'Also, if you give shiptypes 1 or 2 less maximum holds than the game
      'gives the player when they login or get destroyed, then they will still
      'get the excess.
    CASE "G"
      COLOR 10
      PRINT "What should the maximum fighters for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxFtr = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'If you set shiptypes 1 or 2 as having a maximum fighter count less than
      'the initial fighters the game gives a player (definable in Tedit), then
      'TW2002 will still give them more fighters than their ship can carry.
    CASE "H"
      COLOR 10
      PRINT "What should the maximum shields for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxShi = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      COLOR 10
    CASE "J"
      COLOR 10
      PRINT "What should the maximum mines for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxMines = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
    CASE "L"
      COLOR 10
      PRINT "What should the maximum Genesis torps for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxGen = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
    CASE "K"
      COLOR 10
      PRINT "What should the maximum marker beacons for this ship be? (0 to 32000)"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxBeac = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Who in God's name has ever used 32,000 beacons in their entire TW2002
      'trading career? I haven't.
    CASE "I"
      COLOR 10
      PRINT "What should the maximum fighters per attack for this ship be? (0 to 10000)"
      LOCATE 19, 2
      CALL GetInput(0, 10000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxFtrAtt = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Of note is the fact that as of version 1.03D, Gary has yet to fix a bug
      'in TW2002 which only allows four characters of input for the Number
      'of Fighters To Attack With routine. Therefore, no ship can attack with
      'more than 9,999 fighters, even if their shiptype allows it.
    CASE "M"
      COLOR 10
      PRINT "Assuming the SysOp has the Turns Per Day set to 100, what move rate should"
      LOCATE 19, 2
      PRINT " this ship have (Min 1, Max 2000) ?"
      LOCATE 20, 2
      CALL GetInput(1, 2000)
      LOCATE 21, 3
      IF EC = False THEN
        Usermove# = VAL(NewVal)
        ShipType.MoveRate = DBLtoP6R$(Usermove# / 100)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Be wary of setting a shiptype to have less than 5 moves--if someone
      'installs that ship on a game with less than the 100 turns it is based
      'on, the player might not get any turns at all. (I wouldn't worry about
      'it; they can always change it) Also, be careful of giving a ship too
      'many turns--a player can be in a game indefinitely, and if some insane
      'SysOp makes a game with 1500 or so turns (he should be shot), the
      'integer can overflow.
    CASE "O"
      COLOR 10
      PRINT "What should the offensive odds for this ship be? (Min 0.1, Max 32.0)"
      LOCATE 19, 2
      COLOR 1
      PRINT " > ";
      COLOR 11
      NewVal$ = GetLin(4, Numeric + ".")
      Odds = VAL(NewVal$)
      LOCATE 20, 3
      IF Odds >= .1 AND Odds <= 32 THEN
        ShipType.OffOdds = Odds * 10
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Try to resist the temptation to give lots of ships combat odds higher
      'than 2:1. In fact, few ships should have odds higher than 1.4:1, and
      'they should be suitably crippled in some other manner. A point of notice
      'is that it takes 65535 damage points to destroy the StarDock and Class 0
      'ports, so try to avoid making ships which can deliver that many points
      'of damage in one or two attacks. (IE, the existing Scout Marauder can,
      'through a bug in the game, be loaded with 32000 fighters, and in time
      'can destroy these ports. A ship with 6.5:1 odds can do it in one punch
      'if its MaxFtrAtt is 9999.
    CASE "1"
      COLOR 12
      IF ShipNum = SF.D THEN
        PRINT "Note: If you set this to yes, this ship will still only be capable of"
        LOCATE 19, 3
        PRINT "carrying a density scanner. You can change this in the [+] Flags."
        LOCATE 20, 3
      END IF
      COLOR 10
      PRINT "Should this ship be capable of carrying a Long Range Scanner? (Y/N) ";
      COLOR 14
      LL$ = UCASE$(GetKey("YNyn"))
      IF LL$ = "Y" THEN
        PRINT "Yup"
        ShipType.LRS = CHR$(1)
      ELSE
        PRINT "Nah"
        ShipType.LRS = CHR$(0)
      END IF
    CASE "2"
      COLOR 10
      PRINT "Should this ship be capable of carrying a TransWarp Drive? (Y/N) ";
      COLOR 14
      LL$ = UCASE$(GetKey("YNyn"))
      IF LL$ = "Y" THEN
        PRINT "Yup"
        ShipType.TWD = CHR$(1)
      ELSE
        PRINT "Nah"
        ShipType.TWD = CHR$(0)
      END IF
    CASE "3"
      COLOR 10
      PRINT "Should this ship be capable of carrying a Planet Scanner? (Y/N) ";
      COLOR 14
      LL$ = UCASE$(GetKey("YNyn"))
      IF LL$ = "Y" THEN
        PRINT "Yup"
        ShipType.PLS = CHR$(1)
      ELSE
        PRINT "Nah"
        ShipType.PLS = CHR$(0)
      END IF
    CASE "4"
      COLOR 10
      PRINT "What should the maximum Photon Missiles for this ship be?"
      LOCATE 19, 2
      CALL GetInput(0, 32000)
      LOCATE 20, 3
      IF EC = False THEN
        ShipType.MaxPHM = VAL(NewVal)
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'Keep in mind that Photon Missiles are a nasty weapon. They should be
      'rare, and ships should not be able to carry very many of them.
    CASE "*"
      COLOR 10
      PRINT "Filename (no extension) : ";
      FiName$ = GetLin(8, DOS)
      EC = 0
      IF FiName$ <> "" THEN
        Filename = FiName$
        LOCATE 19, 3
        COLOR 25
        PRINT "Creating ShipType Kit...";
        MakeKit (Filename)
        COLOR 9
        LOCATE 19, 3
        PRINT "Creating ShipType Kit... Created.";
      ELSE
        CALL CLSWindow
        LOCATE 18, 3
        Pstra ("~HAborted. Nothing Done.")
      END IF
      EC = 0
      'This creates a basic ShipEdit ShipKit, no frills. If you want to play
      'around with this ShipKit and alter its internals, you need to use
      'KitWorks, available (also with source code) under the filename of
      'TWKITxxx.ZIP, where xxx is the version number. (currently 0.10 as of
      '4/26/93)
    CASE "+"
      Flags
      BLOAD "SHIPEDIT.OVR"
    'CASE "?"
    '  Help
    '  BLOAD "SHIPEDIT.OVR"
      'I haven't figured out a damn thing in ShipEdit that isn't fairly self-
      'explanatory, except for maybe the Summary routine. therefore, I've
      'neglected writing a help routine.
    CASE "^"
      Summary
      BLOAD "SHIPEDIT.OVR"
      'This calls the Summary screen, and then puts the Main Menu back.
    CASE "["
      PutData
      IF ShipNum > 0 THEN
        ShipNum = ShipNum - 1
      ELSE
        ShipNum = 15
      END IF
      'Moves back one ShipType. If at the first shiptype, it wraps around to
      'the last.
    CASE "]"
      PutData
      IF ShipNum < 15 THEN
        ShipNum = ShipNum + 1
      ELSE
        ShipNum = 0
      END IF
      'Moves forward one ShipType. If at the last shiptype, it wraps around to
      'the first.
    CASE "S"
      COLOR 10
      PRINT "What should the minimum alignment to buy ship #9 be? (-32767 to 32767)"
      LOCATE 19, 2
      CALL GetInput(-32767, 32767)
      LOCATE 20, 3
      IF EC = False THEN
        Align = VAL(NewVal)
        IF V103D THEN
          PUT #4, 238171, Align
        ELSE
          PUT #4, 238152, Align
        END IF
        Pstra ("~COkay.")
      ELSE
        Pstra ("~HNothing Done.")
      END IF
      'IMPORTANT: This is *only* the alignment required to buy Ship #9, not
      'the alignment required to stay alive once you're in it. In other words,
      'if a player with an evil alignment warps into the same sector as any of
      'the three Feds, he will be killed instantly and without a chance.
      'Therefore, try to avoid setting this value to less than 0--in fact, the
      'best use of it is setting it higher and making the ship better.
    CASE "Q"
      COLOR 14
      PRINT "Quitting ShipEdit..."
      EXIT DO
      'Quits.
  END SELECT
  IF (UCASE$(TI$) <> "[" AND UCASE$(TI$) <> "]") THEN PutData
  'If the user isn't moving from ship to ship, then it puts the data into
  'TW2002. This is for a very simple reason--if I put the data back once
  'one had moved to a new ship, it would put the data for the previous ship
  'into the new slot. (Since ShipNum had changed)
LOOP
TheEnd
GOTO Ender
Erred:
COLOR 12
IF ERR = 200 THEN
  COLOR 12
  PRINT "Invalid Kit Filename or Kit File not ShipEdit-compatible!"
  COLOR 14
  PRINT "  The Kit Filename you specified was either..."
  PRINT "    - Not the required 1083 bytes long"
  PRINT "    - Not compatible with the ShipEdit program"
  PRINT "    - Nonexistent"
  PRINT "  All ShipEdit Kit Files must..."
  PRINT "    - Be 1083 bytes long"
  PRINT "    - Follow the ShipEdit record structure, including the phrase"
  PRINT "      'TW2002 ShipEdit Kit File' followed by the EOF character"
  PRINT "      as the file header."
  PRINT "    - Exist. :) You can create a Kit File via the '*' command from"
  PRINT "      the ShipEdit program."
  RESUME Ender
  'Since Kits are only loaded from the commandline, it's safe to error out
  'instead of aborting as is done in KitWorks. ShipEdit ShipKits *must* contain
  'the header (first 25 characters) of "TW2002 ShipEdit Kit File", followed by
  'the End-Of-File character (ASCII 26), in order to be compatible with any
  'version of ShipEdit that supports Kits.
ELSEIF ERR = 201 THEN
  COLOR 12
  PRINT "Trade Wars 2002 was NOT found in this directory!"
  PRINT "(This, by the way, is a fairly serious boo-boo)"
  COLOR 14
  PRINT "  ShipEdit must be run either in your TradeWars 2002 directory, or in one which"
  PRINT "has ALL of the following files:"
  COLOR 13
  PRINT "  - SHIPSTAT.DAT - 720 bytes"
  PRINT "  - TW2002.EXE - 87504 bytes in v1.03D, 86736 bytes in v1.03"
  PRINT "  - TW2002.OVR - 347562 bytes in v1.03D, 347511 bytes in v1.03"
  PRINT "  - TEDIT.EXE - 64224 bytes in v1.03D, 63104 bytes in v1.03"
  COLOR 14
  PRINT "  In addition to any ShipKits, which must have an extension of .KIT and be 1083"
  PRINT "bytes in length. Please rectify this error."
  RESUME Ender
  'Fairly self-explanatory. Someone screwed up and ran ShipEdit in a directory
  'that didn't have TW2002 in it.
ELSEIF ERR = 202 THEN
  COLOR 12
  PRINT "TW2002.EXE was invalid!"
  COLOR 14
  PRINT "  ShipEdit determines the version of TW2002 by looking at the size of the"
  PRINT "TW2002.EXE file. In version 1.03D, this file is 87504 bytes long, and in the"
  PRINT "original version 1.03 standard, it is 86736 bytes long. Your TW2002.EXE was"
  PRINT "NEITHER."
  COLOR 5
  PRINT "  1.03 and 1.03D are the only versions currently supported by ShipEdit. If you"
  PRINT "have an earlier version, ";
  COLOR 13
  PRINT "please upgrade."
  RESUME Ender
  'If TW2002.EXE exists, but is not either 86736 or 87540 bytes long, then
  'ShipEdit assumes that this is *not* a copy of v1.03 or v1.03D of TW2002.
ELSEIF ERR = 203 THEN
  COLOR 12
  PRINT NewPath; "SHIPEDIT.OVR Not Found!"
  COLOR 14
  PRINT "  The file SHIPEDIT.OVR was not found in the path you specified--and if you"
  PRINT "did not specify a path, the file was apparently not in the current directory"
  PRINT "either! ShipEdit absolutely REQUIRES that this file be in the same directory"
  PRINT "it gets all of the TW2002 data from."
ELSEIF ERR = 204 THEN
  COLOR 12
  PRINT "SHIPEDIT.OVR was an invalid size!"
  COLOR 14
  PRINT "  In this version of ShipEdit, the file SHIPEDIT.OVR is 4367 bytes long. If"
  PRINT "you are using the SHIPEDIT.OVR file from a different version of ShipEdit, the"
  PRINT "program may not work correctly."
ELSE
  CLS
  PRINT "Errorlevel"; ERR; "occurred at "; TIME$; " on "; DATE$; "."
  RESUME Ender
  'If an error comes up that ShipEdit can't handle, it aborts with a
  'generic errorlevel, but won't lock up.
END IF
Ender:
  'If an error occurred, or a Kit was installed, then ShipEdit resumes at this
  'point and doesn't print out the "plug".
COLOR 7, 0
END

DEFSNG A-Z
FUNCTION CLon$ (LongVal&)
CLon$ = RTRIM$(LTRIM$(STR$(LongVal&)))
  'Function to trim the excess spaces from a LONG int.
END FUNCTION

SUB CLSWindow
FOR Wind = 18 TO 23
  LOCATE Wind, 2
  PRINT STRING$(78, 32)
NEXT Wind
  'Clears the dialogue window at the bottom of the screen. If you alter the
  'size of the screen or dialogue window, be sure to alter this routine so
  'it will work properly.
END SUB

FUNCTION CVal$ (IntVal%)
CVal$ = RTRIM$(LTRIM$(STR$(IntVal%)))
  'Function to trim the excess spaces from an INTEGER.
END FUNCTION

DEFINT A-Z
SUB Flags
CLS
Pstra ("~E[~1TW2002 ~DFlagged ShipTypes~E]~e~!")
PRINT " ~~~~~~~~~~~~~~~~~~~~~~~~"
DO
  Pstra ("~E<~DF~E] ~1Ship Given To Newbies    ~h~D")
  PRINT STR$(SF.F)
  Pstra ("~E<~DK~E] ~1Ship Given When Killed   ~h~D")
  PRINT STR$(SF.K)
  Pstra ("~E<~DJ~E] ~1Ship Cannot Join Corps   ~h~D")
  PRINT STR$(SF.J)
  Pstra ("~E<~DC~E] ~1Ship For CEOs Only       ~h~D")
  PRINT STR$(SF.C)
  Pstra ("~E<~DR~E] ~1Ship Requires Align      ~h~D")
  PRINT STR$(SF.R)
  Pstra ("~E<~DE~E] ~1Evil Plyr in Ship Killed ~h~D")
  PRINT STR$(SF.E)
  Pstra ("~E<~DD~E] ~1Density Scanners Only    ~h~D")
  PRINT STR$(SF.D)
  Pstra ("~E<~D1~E] ~1Combat Scanner Ship 1    ~h~D")
  PRINT STR$(SF.S1)
  Pstra ("~E<~D2~E] ~1Combat Scanner Ship 2    ~h~D")
  PRINT STR$(SF.S2)
  Pstra ("~E<~DQ~E] ~1Quit and Return to ShipEdit~E~!")
  Pstra ("Choose ~e: ~D")
  ZZ$ = UCASE$(GetKey("12CDEFJKQRcdefjkqr"))
  SELECT CASE ZZ$
    CASE "Q"
      PRINT "Quit"
      IF V103D THEN
        A$ = CHR$(SF.E)
        PUT #2, 9568, A$
        A$ = CHR$(SF.C)
        PUT #4, 238229, A$
        A$ = CHR$(SF.D)
        PUT #4, 244014, A$
        PUT #4, 279754, SF.F
        A$ = CHR$(SF.J)
        PUT #4, 84493, A$
        PUT #4, 279743, SF.K
        A$ = CHR$(SF.R)
        PUT #4, 238159, A$
        A$ = CHR$(SF.S1)
        PUT #4, 144136, A$
        A$ = CHR$(SF.S2)
        PUT #4, 144124, A$
      ELSE
        A$ = CHR$(SF.E)
        PUT #2, 9457, A$
        A$ = CHR$(SF.C)
        PUT #4, 238210, A$
        A$ = CHR$(SF.D)
        PUT #4, 243995, A$
        PUT #4, 279735, SF.F
        A$ = CHR$(SF.J)
        PUT #4, 84474, A$
        PUT #4, 279743, SF.K
        A$ = CHR$(SF.R)
        PUT #4, 238140, A$
        A$ = CHR$(SF.S1)
        PUT #4, 144117, A$
        A$ = CHR$(SF.S2)
        PUT #4, 144105, A$
      END IF
      EXIT DO
    CASE "1"
      PRINT "Combat Scanner Ship 1"
      COLOR 10
      PRINT "  There are two ships which have combat scanners. While not affecting the"
      PRINT "odds of the ship, they nevertheless give the player an advantage. Combat"
      PRINT "Scanners give an estimate of an opponents shield capacity, shown as a"
      PRINT "percentage of that shiptype's maximum shield capacity. All values are not"
      PRINT "equal--a Battleship with 20% shields is a different story than an Escape Pod"
      PRINT "with 100%, to use an analogy from the standard shiptypes."
      PRINT "  Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.S1 = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "2"
      PRINT "Combat Scanner Ship 2"
      COLOR 10
      PRINT "  There are two ships which have combat scanners. While not affecting the"
      PRINT "odds of the ship, they nevertheless give the player an advantage. Combat"
      PRINT "Scanners give an estimate of an opponents shield capacity, shown as a"
      PRINT "percentage of that shiptype's maximum shield capacity. All values are not"
      PRINT "equal--a Battleship with 20% shields is a different story than an Escape Pod"
      PRINT "with 100%, to use an analogy from the standard shiptypes."
      PRINT "  Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.S2 = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "C"
      PRINT "CEO-Only SHip"
      COLOR 10
      PRINT "The ship flagged by this function will only be available for purchase by the"
      PRINT "CEO of a corporation. (In the standard TW2002 set, this is Ship#5)"
      PRINT "Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.C = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "D"
      PRINT "Density-Only SHip"
      COLOR 10
      PRINT "This flag determines the maximum Long-Range Scan level this ship can be fitted"
      PRINT "with. If the LRS variable is set to "; Yes; " in ShipEdit, this ship can still"
      PRINT "only purchase a Density Scanner--Holo Scanners are not available. Of course, if"
      PRINT "the LRS variable is set to "; No; ", then the ship cannot have a Long Range Scanner"
      PRINT "regardless of the value of this flag."
      PRINT "Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.D = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "E"
      PRINT "Ship Hazardous to Evil Players' Health"
      COLOR 10
      PRINT "Usually used in conjunction with a minimum alignment check, this flag is used"
      PRINT "to determine whether or not Evil players can keep this ship. If a Fed StarShip"
      PRINT "ever happens upon an evil player in one of these, the player will be decimated."
      PRINT "Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.E = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "F"
      PRINT "First Ship Given"
      COLOR 10
      PRINT "This is the first ship given in the TW2002 game when a new player logs in. It"
      PRINT "defaults to 1 in the standard TW2002 data set, but you can set it to any valid"
      PRINT "shiptype to confuse the hell out of your players."
      PRINT "This flag cannot be disabled--there must be a ship that players begin with."
      COLOR 9
      PRINT "Which Ship do you want? (0-15) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 16 AND VAL(DD$) > -1 THEN
          SF.F = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "J"
      PRINT "Ship Which Cannot Join Corps"
      COLOR 10
      PRINT "Usually used in conjunction with the CEO-only flag, this makes it so that"
      PRINT "players in the flagged ship cannot join a Corporation while they possess that"
      PRINT "ship."
      PRINT "Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.J = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "K"
      PRINT "Killed Players' Ship"
      COLOR 10
      PRINT "This is the ship given to players who have been killed, and have just now"
      PRINT "returned to the game. It defaults to 2 in the standard TW2002 data set, but"
      PRINT "it can be readily changed if you have something else in mind."
      PRINT "This flag cannot be disabled. If you want to make it so that players cannot"
      PRINT "log back in once they have been destroyed once, you will need to take care of"
      PRINT "delinquent players by hand."
      COLOR 9
      PRINT "Which Ship do you want? (0-15) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 16 AND VAL(DD$) > -1 THEN
          SF.K = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
    CASE "R"
      PRINT "Required-Alignment Ship"
      COLOR 10
      PRINT "The flagged ship will require players to have a definable amount of alignment"
      PRINT "before they can purchase this ship. Note that unless you have hexed this"
      PRINT "otherwise, the StarDock will always tell a player with insufficient align that"
      PRINT "he requires x amount to buy the 'StarShip'."
      PRINT "Setting this to 16 will disable this flag."
      COLOR 9
      PRINT "Which Ship do you want? (0-16) ";
      DD$ = GetLin(2, Numeric)
      IF DD$ <> "" THEN
        IF VAL(DD$) < 17 AND VAL(DD$) > -1 THEN
          SF.R = VAL(DD$)
        ELSE
          COLOR 12
          PRINT "Invalid Value."
        END IF
      ELSE
        COLOR 15
        PRINT "Nothing Done."
      END IF
  END SELECT
  PRINT
LOOP
END SUB

DEFSNG A-Z
SUB GetData
  A$ = CHR$(0)
  IF V103D THEN
    GET #2, 85399 + (ShipNum * 23), RawString
    GET #2, 84612 + (ShipNum * 7), ShipAbb
    GET #2, 9569, A$
    SF.E = ASC(A$)
    GET #4, 238229, A$
    SF.C = ASC(A$)
    GET #4, 244014, A$
    SF.D = ASC(A$)
    GET #4, 279754, SF.F
    GET #4, 84493, A$
    SF.J = ASC(A$)
    GET #4, 279762, SF.K
    GET #4, 238159, A$
    SF.R = ASC(A$)
    GET #4, 144136, A$
    SF.S1 = ASC(A$)
    GET #4, 144124, A$
    SF.S2 = ASC(A$)
    GET #4, 238171, Align
  ELSE
    GET #2, 84654 + ((ShipNum - 1) * 23), RawString
    GET #2, 83851 + ((ShipNum - 1) * 7), ShipAbb
    GET #2, 9457, A$
    SF.E = ASC(A$)
    GET #4, 238210, A$
    SF.C = ASC(A$)
    GET #4, 243995, A$
    SF.D = ASC(A$)
    GET #4, 279735, SF.F
    GET #4, 84474, A$
    SF.J = ASC(A$)
    GET #4, 279743, SF.K
    GET #4, 238140, A$
    SF.R = ASC(A$)
    GET #4, 144117, A$
    SF.S1 = ASC(A$)
    GET #4, 144105, A$
    SF.S2 = ASC(A$)
    GET #4, 238152, Align
  END IF
  GET #1, ShipNum + 1, ShipType
  Odds = ShipType.OffOdds / 10
  mR = 100 * (P6RtoDBL(ShipType.MoveRate))
  Holds& = ShipType.HoldCost
  Drive& = ShipType.DrivCost
  Compu& = ShipType.CompCost
  Hulls& = ShipType.HullCost
  ShipPrice = Holds& + Drive& + Compu& + Hulls&
  
END SUB

DEFINT A-Z
SUB GetInput (MinVal&, MaxVal&)
COLOR 1
PRINT " > ";
COLOR 11
IF MinVal& < 0 THEN Filter$ = Numeric + "-" ELSE Filter$ = Numeric
IF LEN(CLon(MaxVal&)) > LEN(CLon(MinVal&)) THEN MaxLen = LEN(CLon(MaxVal&)) ELSE MaxLen = LEN(CLon(MinVal&))
NewVal = GetLin(MaxLen, Filter$)
TheVal& = INT(VAL(NewVal))
IF TheVal& > MaxVal& OR TheVal& < MinVal& OR NewVal = "" THEN
  EC = True
ELSE
  EC = False
END IF
END SUB

DEFSNG A-Z
SUB Help

END SUB

SUB InstKit
OPEN NewPath + Filename + ".KIT" FOR BINARY AS #5

IF LOF(5) > 25 THEN GET #5, 1, FileHeader

IF LOF(5) = 0 THEN
  CLOSE #5
  KILL NewPath + Filename + ".KIT"
  ERROR 200
ELSEIF LOF(5) <> 1083 THEN
  CLOSE #5
  ERROR 200
ELSEIF FileHeader <> "TW2002 ShipEdit Kit File" + CHR$(26) THEN
  CLOSE #5
  ERROR 200
END IF
FIN$ = Filename
FIN$ = RTRIM$(Filename)

GET #5, 26, Align
FOR ShipNum = 0 TO 15
  GET #5, KitNum, RawString
  GET #5, KitNum + 23, ShipAbb
  GET #5, KitNum + 29, ShipType.HoldCost
  GET #5, KitNum + 31, ShipType.DrivCost
  GET #5, KitNum + 33, ShipType.CompCost
  GET #5, KitNum + 35, ShipType.HullCost
  GET #5, KitNum + 37, ShipType.MaxHolds
  GET #5, KitNum + 39, ShipType.InitHolds
  GET #5, KitNum + 41, ShipType.MoveRate
  GET #5, KitNum + 47, ShipType.MaxFtr
  GET #5, KitNum + 49, ShipType.MaxShi
  GET #5, KitNum + 51, ShipType.OffOdds
  GET #5, KitNum + 53, ShipType.MaxMines
  GET #5, KitNum + 55, ShipType.MaxBeac
  GET #5, KitNum + 57, ShipType.MaxGen
  GET #5, KitNum + 59, ShipType.LRS
  GET #5, KitNum + 60, ShipType.TWD
  GET #5, KitNum + 61, ShipType.PLS
  GET #5, KitNum + 62, ShipType.MaxPHM
  GET #5, KitNum + 64, ShipType.MaxFtrAtt
  CALL PutData
NEXT ShipNum
END SUB

FUNCTION KitNum%
KitNum = (28 + (ShipNum) * 67&) - ShipNum
END FUNCTION

SUB MakeKit (FiNa$)
OPEN NewPath + FiNa$ + ".KIT" FOR BINARY AS #5
FileHeader = "TW2002 ShipEdit Kit File" + CHR$(26)
PUT #5, 1, FileHeader
PUT #5, 26, Align
SNum% = ShipNum
FOR ShipNum = 0 TO 15
  GetData
  PUT #5, KitNum, RawString
  PUT #5, KitNum + 23, ShipAbb
  PUT #5, KitNum + 29, ShipType.HoldCost
  PUT #5, KitNum + 31, ShipType.DrivCost
  PUT #5, KitNum + 33, ShipType.CompCost
  PUT #5, KitNum + 35, ShipType.HullCost
  PUT #5, KitNum + 37, ShipType.MaxHolds
  PUT #5, KitNum + 39, ShipType.InitHolds
  PUT #5, KitNum + 41, ShipType.MoveRate
  PUT #5, KitNum + 47, ShipType.MaxFtr
  PUT #5, KitNum + 49, ShipType.MaxShi
  PUT #5, KitNum + 51, ShipType.OffOdds
  PUT #5, KitNum + 53, ShipType.MaxMines
  PUT #5, KitNum + 55, ShipType.MaxBeac
  PUT #5, KitNum + 57, ShipType.MaxGen
  PUT #5, KitNum + 59, ShipType.LRS
  PUT #5, KitNum + 60, ShipType.TWD
  PUT #5, KitNum + 61, ShipType.PLS
  PUT #5, KitNum + 62, ShipType.MaxPHM
  PUT #5, KitNum + 64, ShipType.MaxFtrAtt
NEXT ShipNum
ShipNum = SNum%
GetData
END SUB

DEFINT A-Z
SUB ParseCLine
Words = 0
in = False
StrLen = LEN(COMMAND$)
FOR Chr = 1 TO StrLen
  CutItOut$ = MID$(COMMAND$, Chr, 1)
  IF CutItOut$ <> "/" THEN
    IF NOT in THEN
      IF Words = 5 THEN EXIT FOR
      Words = Words + 1
      in = True
      END IF
    Parm$(Words) = Parm$(Words) + CutItOut$
  ELSE
    in = False
  END IF
NEXT Chr
FOR x = 1 TO 3
  Parm$(x) = RTRIM$(LTRIM$(Parm$(x)))
  IF UCASE$(Parm$(x)) = "BU" THEN
    Backup = True
  ELSEIF UCASE$(LEFT$(Parm$(x), 2)) = "N:" THEN
    IF LEN(Parm$(x)) < 5 THEN
      ShipNum = VAL(RIGHT$(Parm$(x), LEN(Parm$(x)) - 2))
      IF ShipNum > 15 OR ShipNum < 0 THEN ShipNum = 0
      PRINT "   - Jumping Automatically to Ship #"; LTRIM$(STR$(ShipNum))
    END IF
  ELSEIF UCASE$(LEFT$(Parm$(x), 2)) = "P:" THEN
    NewPath = UCASE$(RIGHT$(Parm$(x), LEN(Parm$(x)) - 2))
  ELSEIF UCASE$(LEFT$(Parm$(x), 2)) = "K:" THEN
    Filename = UCASE$(RIGHT$(Parm$(x), LEN(Parm$(x)) - 2))
    Kit = True
    FiNa$ = Filename: FiNa$ = LTRIM$(RTRIM$(FiNa$))
    PRINT "   - Preparing to install "; FiNa$; ".KIT"
  ELSEIF UCASE$(Parm$(x)) = "103D" THEN
    V103D = True
  END IF
NEXT x
END SUB

DEFSNG A-Z
SUB ParseShipFac
  'This routine parses the ship factors of the ship currently stored in the
  'ShipType variable. These routines and I make no claim to be perfect (since
  'neither of us are), but this does give one a (*very*) general idea of how
  'use(ful/less) this ship is.
SM& = ShipType.MaxHolds
MMR& = mR
MMFac = ((SM& * MMR&) + (ASC(ShipType.TWD) * 20&) + (ASC(ShipType.LRS) * 10&)) * 2.5
OffFac = ((Odds * (ShipType.MaxFtr / 10)) + ShipType.MaxFtrAtt) + (ASC(ShipType.PLS) * 200&) + (ShipType.MaxPHM * 10&) + ShipType.MaxMines
DefFac = (Odds * (ShipType.MaxShi / 10)) + (ASC(ShipType.LRS) * 50&)
ShipFac = (MMFac) + (OffFac) + (DefFac) - INT(ShipPrice / 10)
IF ShipFac < 0 THEN ShipFac = 0
END SUB

SUB PutData
  IF V103D THEN
    PUT #2, 85399 + (ShipNum * 23), RawString
    PUT #2, 84612 + (ShipNum * 7), ShipAbb
    PUT #4, 238171, Align
  ELSE
    PUT #2, 84654 + ((ShipNum - 1) * 23), RawString
    PUT #2, 83851 + ((ShipNum - 1) * 7), ShipAbb
    PUT #4, 238152, Align
  END IF
  PUT #1, ShipNum + 1, ShipType
END SUB

FUNCTION SFill$ (StringVar$, MaxLen%)
IF LEN(StringVar$) > MaxLen% THEN SFill$ = "" ELSE SFill$ = STRING$(MaxLen% - LEN(StringVar$), 32)
  'Takes a string variable, and the maximum length that string varaible can be,
  'and if string isn't at its maximum length, it sets SFill$ to a number of
  'spaces equal to the difference. Used to clear remaining output when a value
  'that can change lengths (like the ship name) is put into the same spot, and
  'cures the problem of previous output still being there.
END FUNCTION

SUB Summary
DEFINT A-Z
COLOR 3, 0
CLS
PRINT " ĳ     Ŀ  ĳ Ŀ  Ŀ    "; : COLOR 11: PRINT "Summary of Individual and Group"
COLOR 3: PRINT "Ŀ  Ŀ   ĳ              "; : COLOR 11: PRINT "ShipTypes"
PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT " "; : COLOR 11: PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT "   "; : COLOR 11: PRINT "";
COLOR 3: PRINT ""; : COLOR 11: PRINT ""; : COLOR 3: PRINT " "; : COLOR 11: PRINT ""; : COLOR 3: PRINT "  "; : COLOR 11: PRINT ""; : COLOR 3: PRINT "";
COLOR 9: PRINT ""
COLOR 8: PRINT ""; : COLOR 4: PRINT ""; : COLOR 12: PRINT ""; : COLOR 14: PRINT "Ship Factors/Yours"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"; : COLOR 4: PRINT ""; : COLOR 12: PRINT "";
COLOR 14: PRINT "Overall/Yours"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"
PRINT " "; : COLOR 12: PRINT "Ship Abb/# "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Off Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Def Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Fin Fac "; : COLOR 8: PRINT " "; : COLOR 12
PRINT "Ovr Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Average Overall Ship  "; : COLOR 8: PRINT ""
PRINT "Ĵ "; : COLOR 12: PRINT "Factor:               "; : COLOR 8: PRINT ""
PRINT "                                                 "; : COLOR 12: PRINT "Deviation:            "; : COLOR 8: PRINT ""
PRINT ""
COLOR 8: PRINT ""; : COLOR 4: PRINT ""; : COLOR 12: PRINT ""; : COLOR 14: PRINT "Ship Factors/Standard"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT "Ŀ"; : COLOR 4: PRINT ""; : COLOR 12: PRINT "";
COLOR 14: PRINT "Overall/Standard"; : COLOR 12: PRINT ""; : COLOR 4: PRINT ""; : COLOR 8: PRINT ""
PRINT " "; : COLOR 12: PRINT "Ship Abb/# "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Off Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Def Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Fin Fac "; : COLOR 8: PRINT " "; : COLOR 12
PRINT "Ovr Fac "; : COLOR 8: PRINT " "; : COLOR 12: PRINT "Average Overall Ship  "; : COLOR 8: PRINT ""
PRINT "Ĵ "; : COLOR 12: PRINT "Factor:               "; : COLOR 8: PRINT ""
PRINT "                                                                       "
PRINT ""
COLOR 9: PRINT ""
COLOR 14: PRINT " [ "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Back one ShipType"
COLOR 14: PRINT " ] "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Forward one ShipType"
COLOR 14: PRINT " Q "; : COLOR 9: PRINT " "; : COLOR 11: PRINT "Quit Summary and Return to ShipEdit"

LOCATE 3, 39
COLOR 27
PRINT "Computing..."
DIM Standards(15, 1 TO 4) AS LONG
DIM StandNames(15) AS STRING * 6

FOR x = 0 TO 15
  GET #6, 4016 + (6 * x), StandNames(x)
NEXT x
FOR x = 1 TO 4
  FOR y = 0 TO 15
    GET #6, 4112 + ((x - 1) * 64) + (y * 4), Standards(y, x)
  NEXT y
NEXT x

SN = ShipNum
FOR ShipNum = 0 TO 15
  CALL GetData
  CALL ParseShipFac
  Accum& = Accum& + ShipFac
NEXT ShipNum
ShipNum = SN
Average& = Accum& \ 16&
Accum& = 0&
LOCATE 3, 39
COLOR 11
PRINT "            "

ShNum = ShipNum
DO
  COLOR 11
  CALL GetData
  CALL ParseShipFac
  LOCATE 8, 3
  PRINT ShipAbb; " #"; CVal$(ShipNum); " ";
  LOCATE 8, 16
  PRINT CLon$(OffFac); SFill$(CLon$(OffFac), 7);
  LOCATE 8, 26
  PRINT CLon$(DefFac); SFill$(CLon$(DefFac), 7);
  LOCATE 8, 36
  PRINT CLon$(MMFac); SFill$(CLon$(MMFac), 7);
  LOCATE 8, 46
  PRINT CLon$(ShipFac); SFill$(CLon$(ShipFac), 7);
  LOCATE 7, 65
  PRINT CLon$(Average&); SFill$(CLon$(Average&), 7);
  LOCATE 8, 68
  Dev& = Average& - 17994&
  IF Dev& > 0 THEN PRINT "+"; CLon$(Dev&) ELSE PRINT CLon$(Dev&)
 
  LOCATE 13, 3
  PRINT StandNames(ShipNum); " #"; CVal$(ShipNum); " ";
  LOCATE 13, 16
  PRINT CLon$(Standards(ShipNum, 1)); SFill$(CLon$(Standards(ShipNum, 1)), 7);
  LOCATE 13, 26
  PRINT CLon$(Standards(ShipNum, 2)); SFill$(CLon$(Standards(ShipNum, 2)), 7);
  LOCATE 13, 36
  PRINT CLon$(Standards(ShipNum, 3)); SFill$(CLon$(Standards(ShipNum, 3)), 7);
  LOCATE 13, 46
  PRINT CLon$(Standards(ShipNum, 4)); SFill$(CLon$(Standards(ShipNum, 4)), 7);
  LOCATE 12, 65
  PRINT "17994";
 
  A$ = GetKey("[]Qq")
  SELECT CASE UCASE$(A$)
    CASE "["
      IF ShipNum = 0 THEN ShipNum = 15 ELSE ShipNum = ShipNum - 1
    CASE "]"
      IF ShipNum = 15 THEN ShipNum = 0 ELSE ShipNum = ShipNum + 1
    CASE "Q"
      EXIT DO
  END SELECT
LOOP
ShipNum = ShNum
GetData
  'Lotsa fun. I dare you to try to figure out my coding on this one.
END SUB

SUB TheEnd
LOCATE 19, 1
Pstra ("~B~b<> ~DShipEdit v2.6, (C) 1992, 1993 by Brandon Bannerman ~b<>~B")
FOR x = 1 TO 5
  PRINT STRING$(80, 32);
NEXT x
LOCATE 20, 2
COLOR 10
PRINT "ShipEdit 2.6, released to the Public Domain. No fee required for usage. Send"
PRINT " all donations, bug reports, comments, etc to:"
COLOR 14
PRINT " Brandon Bannerman  27908 84th Ave So  Kent, WA 98032-8625"
Pstra ("~B Western Dist Site ~b: ~BDarkStar StarDock ~b@ ~f(~F206~f)~F431~f-~F1243")
END SUB

